/** @format */
import { PackageType } from '../utils/package-type';
import { Hook } from './hook';
import { Parse } from '../utils/parse';
export interface ComponentConfig {
    Component: string;
    Provider: string;
    Access?: string;
    Extends: any;
    Properties: {
        [key: string]: any;
    };
    Params: any;
    ProjectName: string;
}
export interface VersionCheckParams {
    name: string;
    type: PackageType;
    provider: string;
}
export interface GenerateComponentExeParams {
    list: string[];
    parse: Parse;
    parsedObj: any;
    method: string;
    params: string;
}
export declare function synchronizeExecuteComponentList(list?: any, index?: any, initData?: any): Promise<any>;
export declare function generateSynchronizeComponentExeList({ list, parse, parsedObj, method, params }: GenerateComponentExeParams, equipment: (parse: Parse, projectName: string, parsedObj: any) => Promise<ComponentConfig>): any[];
export declare class ComponentExeCute {
    protected componentConfig: ComponentConfig;
    protected method: string;
    protected componentPath: string;
    protected credentials: any;
    protected isPackageProject: boolean;
    constructor(componentConfig: ComponentConfig, method: string);
    init(): Promise<any>;
    getCredentials(): Promise<any>;
    setCredentials(provider: any): Promise<any>;
    componentExist(): boolean;
    getRemoteComponentVersion({ name, provider, type }: VersionCheckParams): Promise<any>;
    getLocalComponentVersion(): string | null;
    private preLoadNodeModules;
    downLoadAndUnCompressComponent(type: PackageType, name: string, provider: string): Promise<void>;
    downLoadAndUnCompressComponentV2(type: PackageType, name: string, provider: string, version: string): Promise<void>;
    private loadExtends;
    loadPreExtends(extend: Hook | null): Promise<void>;
    loadAfterExtend(extend: Hook | null): Promise<void>;
    loadComponent(): Promise<any>;
    invokeMethod(ComponentClass: any, method: string, data: any): Promise<unknown>;
    executeCommand(): Promise<any>;
    startExecute(): Promise<any>;
}
//# sourceMappingURL=index.d.ts.map