"use strict";
/** @format */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PlatformLoginManager = void 0;
var inquirer = require('inquirer');
var axios_1 = require("axios");
var fs = require("fs-extra");
var os = require("os");
var path = require("path");
var logger_1 = require("../../utils/logger");
var login_error_1 = require("../../error/login-error");
var static_variable_1 = require("../../constants/static-variable");
var gui_service_1 = require("../../gui/gui-service");
var i18n_1 = require("../../utils/i18n");
var CONFIG_COMMAND_MAP = {
    username: {
        type: 'input',
        message: i18n_1.default.__('Please input username'),
        name: 'username',
        default: '',
    },
    password: {
        type: 'password',
        message: i18n_1.default.__('Please input password'),
        name: 'password',
        default: '',
    },
};
var PlatformLoginManager = /** @class */ (function () {
    function PlatformLoginManager() {
    }
    PlatformLoginManager.prototype.init = function (context) {
        return __awaiter(this, void 0, void 0, function () {
            var username, password, gui, guiService, promptList_1, _a, username_1, password_1, password_2;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        username = context.username, password = context.password, gui = context.gui;
                        if (gui) {
                            guiService = new gui_service_1.default('/login');
                            guiService.start();
                            return [2 /*return*/];
                        }
                        if (!(username && password)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.login(context)];
                    case 1:
                        _b.sent();
                        return [3 /*break*/, 8];
                    case 2:
                        promptList_1 = [];
                        if (!(!username && !password)) return [3 /*break*/, 5];
                        Object.keys(CONFIG_COMMAND_MAP).forEach(function (key) {
                            promptList_1.push(CONFIG_COMMAND_MAP[key]);
                        });
                        return [4 /*yield*/, inquirer.prompt(promptList_1)];
                    case 3:
                        _a = _b.sent(), username_1 = _a.username, password_1 = _a.password;
                        return [4 /*yield*/, this.login({ username: username_1, password: password_1 })];
                    case 4:
                        _b.sent();
                        return [3 /*break*/, 8];
                    case 5:
                        if (!(username && !password)) return [3 /*break*/, 8];
                        promptList_1.push(CONFIG_COMMAND_MAP.password);
                        return [4 /*yield*/, inquirer.prompt(promptList_1)];
                    case 6:
                        password_2 = (_b.sent()).password;
                        return [4 /*yield*/, this.login({ username: username, password: password_2 })];
                    case 7:
                        _b.sent();
                        _b.label = 8;
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    PlatformLoginManager.prototype.login = function (loginData) {
        return __awaiter(this, void 0, void 0, function () {
            var options, result, err_1, token, tokenFile;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        logger_1.default.info('In operation......');
                        options = {
                            // url: LOGIN_URL,
                            // type: 'post',
                            timeout: 5000,
                            headers: {
                                'User-Agent': 's',
                            },
                        };
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.post(static_variable_1.SERVERLESS_LOGIN_URL, { username: loginData.username, password: loginData.password }, options)];
                    case 2:
                        result = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        throw new login_error_1.LoginError('Failed to login, error: {{error}}', { error: err_1.message });
                    case 4:
                        if (result.status !== 200) {
                            throw new login_error_1.LoginError('Failed to login, http code: {{code}}', { code: result.status });
                        }
                        if (result.data.Error) {
                            throw new login_error_1.LoginError('Failed to login, code: {{code}}, message: {{msg}}', {
                                code: result.data.Error.Code,
                                msg: result.data.Error.Message,
                            });
                        }
                        token = result.data.Response.Code;
                        if (!fs.existsSync(this.getTokenDir())) {
                            fs.mkdirSync(this.getTokenDir());
                        }
                        tokenFile = this.getTokenFile();
                        if (fs.existsSync(tokenFile)) {
                            fs.removeSync(tokenFile);
                        }
                        fs.writeFileSync(tokenFile, token);
                        logger_1.default.success('Login information obtained successfully.');
                        return [2 /*return*/];
                }
            });
        });
    };
    PlatformLoginManager.prototype.isCurrentLogin = function () {
        return fs.existsSync(this.getTokenFile());
    };
    PlatformLoginManager.prototype.getLoginToken = function () {
        return fs.readFileSync(this.getTokenFile(), 'utf-8');
    };
    PlatformLoginManager.prototype.getTokenFile = function () {
        var dir = this.getTokenDir();
        return path.join(dir, 'login-token');
    };
    PlatformLoginManager.prototype.getTokenDir = function () {
        return path.join(os.homedir(), '.s');
    };
    return PlatformLoginManager;
}());
exports.PlatformLoginManager = PlatformLoginManager;
//# sourceMappingURL=login-manager.js.map