"use strict";
/** @format */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.PluginExeCute = void 0;
var fs = require('fs');
var path = require('path');
var os = require('os');
var axios_1 = require("axios");
var download_manager_1 = require("../utils/download-manager");
var logger = require("../utils/logger");
var package_type_1 = require("../utils/package-type");
var S_PLUGIN_BASE_PATH = path.join(os.homedir(), ".s/plugins");
var static_variable_1 = require("../constants/static-variable");
var TYPE_MAP = (_a = {},
    _a[package_type_1.PackageType.component] = 'Component',
    _a[package_type_1.PackageType.plugin] = 'Plugin',
    _a[package_type_1.PackageType.application] = 'Application',
    _a);
var PluginExeCute = /** @class */ (function () {
    function PluginExeCute(pluginConfig) {
        this.pluginConfig = pluginConfig;
        if (!fs.existsSync(S_PLUGIN_BASE_PATH)) {
            fs.mkdirSync(S_PLUGIN_BASE_PATH);
        }
        var name = this.pluginConfig.name;
        this.pluginPath = path.join(S_PLUGIN_BASE_PATH, "/" + name);
    }
    PluginExeCute.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var name, localVersion, remoteVersion, isSameVersion;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        name = this.pluginConfig.name;
                        if (!!this.pluginExist()) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.downLoadPlugin(package_type_1.PackageType.plugin, name)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 2:
                        localVersion = this.getLocalComponentVersion();
                        return [4 /*yield*/, this.getRemotePluginVersion({ name: name, type: package_type_1.PackageType.plugin })];
                    case 3:
                        remoteVersion = _a.sent();
                        isSameVersion = this.checkVersion(localVersion, remoteVersion);
                        if (!!isSameVersion) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.downLoadPlugin(package_type_1.PackageType.plugin, name)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    PluginExeCute.prototype.pluginExist = function () {
        return fs.existsSync(this.pluginPath);
    };
    PluginExeCute.prototype.getRemotePluginVersion = function (_a) {
        var name = _a.name, type = _a.type;
        return __awaiter(this, void 0, void 0, function () {
            var version, result, e_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        version = null;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.get(static_variable_1.SERVERLESS_CHECK_VERSION_URL, {
                                params: {
                                    name: name,
                                    type: TYPE_MAP[type],
                                },
                            })];
                    case 2:
                        result = _b.sent();
                        if (result.data && result.data.Response && result.data.Response.Version) {
                            version = result.data.Response.Version;
                        }
                        else {
                            // throw new Error("Please Check the plugin name");
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _b.sent();
                        logger.error(e_1.message);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, version];
                }
            });
        });
    };
    PluginExeCute.prototype.getLocalComponentVersion = function () {
        var name = this.pluginConfig.name;
        var pkgFile = path.join(S_PLUGIN_BASE_PATH, "/" + name + "/package.json");
        if (!fs.existsSync(pkgFile)) {
            return null;
        }
        var componentPackageJsonObj = require(pkgFile);
        return componentPackageJsonObj.version;
    };
    PluginExeCute.prototype.checkVersion = function (localVersion, remoteVersion) {
        return remoteVersion === localVersion;
    };
    PluginExeCute.prototype.downLoadPlugin = function (type, name) {
        return __awaiter(this, void 0, void 0, function () {
            var downloadManager, pluginPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        downloadManager = new download_manager_1.DownloadManager();
                        pluginPath = path.join(S_PLUGIN_BASE_PATH, "/" + name);
                        if (!fs.existsSync(pluginPath)) {
                            fs.mkdirSync(pluginPath);
                        }
                        return [4 /*yield*/, downloadManager.downloadTemplateFromAppCenter(type, name, pluginPath)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    PluginExeCute.prototype.loadPlugin = function () {
        return __awaiter(this, void 0, void 0, function () {
            var PluginModule;
            return __generator(this, function (_a) {
                PluginModule = require(this.pluginPath);
                return [2 /*return*/, PluginModule];
            });
        });
    };
    return PluginExeCute;
}());
exports.PluginExeCute = PluginExeCute;
//# sourceMappingURL=index.js.map